%define khversion 3.0
%define khrelease 011

Summary: Userspace and Asterisk support for KHOMP Telephony interface cards
Name: asterisk-chan_khomp
Version: %{khversion}
Release: %{khrelease}.0
License: Proprietary
Group: Applications/Internet
URL: http://www.khomp.com.br/
Source0: channel_%{khversion}_%{khrelease}_i686.sh.gz
Source1: channel_%{khversion}_%{khrelease}_x86-64.sh.gz
Source2: khomp-install-stubs.sh
Patch0: khomp-fix-root-installation.patch
Patch1: khomp-chkconfig-support.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: unzip, bash
Requires: asterisk >= 2009020507:1.8.0

%description

This package contains the userspace support for the KHOMP telephony drivers.


%package docs
Summary: Userspace and Asterisk support for KHOMP Telephony interface cards - Documentation
Group: Applications/Internet
Requires: %{name}

%description docs

This package contains documentation for the KHOMP telephony drivers and 
userspace support.


%prep

rm -rf %{name}-%{version} 
mkdir %{name}-%{version}
%setup -T -D

if [ %{_arch} == "x86_64" ] ; then
	zcat %{SOURCE1} > khomp_shar.sh
else
	zcat %{SOURCE0} > khomp_shar.sh
fi

# The following method is ripped from the shar header for the KHOMP installer
PKG_SELF=khomp_shar.sh
PKG_ZIP=khomp_shar.zip
PKG_TGZ=khomp.tar.gz

# Find the marker that indicates the start of the ZIP data
line=`grep -an MARKER khomp_shar.sh | cut -d: -f1 | tail -n1` || exit 1

# Convert line offset into byte offset
size=`head -n "${line}" khomp_shar.sh | wc -c` || exit 1

# Strip header into zipfile
dd bs=${size} skip=1 if="${PKG_SELF}" of="${PKG_ZIP}" &>/dev/null || exit 1
rm -f "${PKG_SELF}"

# Unpack zipfile
unzip -p "${PKG_ZIP}" > "${PKG_TGZ}" || exit 1
rm -f "${PKG_ZIP}"

# Find out final directory name
PACKDIR=`tar -ztf "${PKG_TGZ}" 2>/dev/null | head -n1 | cut -d'/' -f1`
tar -xzf "${PKG_TGZ}"
rm -f "${PKG_TGZ}"
mv "${PACKDIR}"/* .
rmdir "${PACKDIR}"

%patch0 -p1
%patch1 -p1
cp %{SOURCE2} .


%install

rm -rf %{buildroot}
mkdir -p %{buildroot}
./khomp-install-stubs.sh %{buildroot} %{_libdir}

# Proper place for initscripts is /etc/rc.d/init.d
mkdir -p %{buildroot}%{_initrddir}
mv %{buildroot}/etc/init.d/* %{buildroot}%{_initrddir}
rmdir %{buildroot}/etc/init.d/

# Remove /usr/doc - this goes in a separate package
rm -rf %{buildroot}/usr/doc

# Some programs want %{_libdir}/libk3l.so which should be a symlink to 
# %{_libdir}/libk3l-client.so , but rpm does not pick up the symlink as a proper
# provides. I try to provide a hard link instead.
rm %{buildroot}%{_libdir}/libk3l.so
OLDPWD=`pwd`
cd %{buildroot}%{_libdir}
ln libk3l-client.so libk3l.so
cd "$OLDPWD"

# Re-do the symlinks since they encode paths into buildroot
if [ %{_arch} == "x86_64" ] ; then
    cd %{buildroot}/usr/lib
    rm -f k3l.so kva.so libk3l.so libkgw.so libkisdn.so libkva.so
    for i in k3l.so kva.so libk3l.so libkgw.so libkisdn.so libkva.so libk3l-server.so; do
        ln -s ../lib64/$i
    done
fi

rm `find %{buildroot} -name '*.orig'`

%clean
%{__rm} -rf %{buildroot}


%post
if [ $1 -eq 1 ] ; then
	chkconfig --add khompdrv
	chkconfig --add kserver
	chkconfig khompdrv on
	chkconfig kserver on
fi
/sbin/ldconfig


%preun
if [ $1 -eq 0 ] ; then
	/sbin/service kserver stop
	/sbin/service khompdrv stop
	/sbin/chkconfig --del kserver
	/sbin/chkconfig --del khompdrv
fi

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/asterisk/khomp.conf
%{_initrddir}/kserver
%{_initrddir}/khompdrv
%config(noreplace) %{_sysconfdir}/khomp/config/*
%config(noreplace) %{_sysconfdir}/khomp/config/.default.*
%{_sysconfdir}/khomp/2.1.0/*
%{_sysconfdir}/khomp/languages/*
%{_sysconfdir}/kserver/*
/opt/khomp/*
%{_libdir}/*
/usr/lib/*
%{_sbindir}/*
%dir %{_localstatedir}/log/khomp*
%doc README_*.txt

%files docs
%defattr(-,root,root,-)
%doc docs/*


%changelog
* Fri Oct 21 2011 - Alex Villacis Lasso <a_villacis@palosanto.com> 3.0-011.0
- Update to 3.0-011

* Tue Aug  9 2011 - Alex Villacis Lasso <a_villacis@palosanto.com> 3.0-010.1
- Fix init.d service start order - khompdrv must start BEFORE kserver, not after.

* Wed Jul 27 2011 - Alex Villacis Lasso <a_villacis@palosanto.com> 3.0-010.0
- Initial packaging for Elastix

